require_relative "./whoisxmlapi/version"
require_relative "./whoisxmlapi/contact"
require_relative "./whoisxmlapi/result"
require_relative "./whoisxmlapi/good"
require_relative "./whoisxmlapi/un_parsable"
require_relative "./whoisxmlapi/bad_domain"
require_relative "./whoisxmlapi/unavailable"
require_relative "./whoisxmlapi/client"
require_relative "./whoisxmlapi/rwhois_result"

module WhoisXMLAPI

  def self.whois_path=(path)
    @whois_path = path
  end

  def self.whois_path
    @whois_path ? @whois_path : "https://www.whoisxmlapi.com/whoisserver/WhoisService"
  end


  def self.rwhois_path=(path)
    @rwhois_path = path
  end

  def self.rwhois_path
    @rwhois_path ? @rwhois_path : "https://reverse-whois-api.whoisxmlapi.com/api/v2"
  end


  def self.account_path=(path)
    @account_path = path
  end

  def self.account_path
    @account_path ? @account_path : "https://user.whoisxmlapi.com/service/account-balance"
  end


  def self.api_key
    @api_key
  end

  def self.api_key=(key)
    @api_key = key
  end


  def self.cache_length=(leng)
    @cache_length = leng
  end

  def self.cache_length
    @cache_length
  end


  def self.cache=(bool)
    @cache = bool
  end

  def self.cache
    @cache.nil? or @cache.blank? ? true : @cache
  end


  def self.rwhois_mode=(mode)
    @rwhois_mode = mode
  end

  def self.rwhois_mode
    @rwhois_mode ? @rwhois_mode : 'sample_purchase'
  end


  def self.callbacks
    @callbacks ||= {}
    @callbacks[:whois] ||= []
    @callbacks[:rwhois] ||= []
    @callbacks
  end


  def self.logger
    @logger ||= Logger.new(STDOUT)
    @logger
  end

  def self.logger=(log)
    @logger = log
  end


  def self.configure
    yield self
  end

end
