module WhoisXMLAPI
  class Contact
    include Mongoid::Document
    include Mongoid::Timestamps

    belongs_to :contactable, :polymorphic => true
    # Actual indexing is performed in db_mongoid_extend.rake
    # index([
    #   [ :contactable_id, Mongo::ASCENDING ],
    #   [ :contactable_type, Mongo::ASCENDING ]
    # ])
    index({contactable_id: 1, contactable_type: 1})

    field :name
    field :organization
    field :street1
    field :street2
    field :city
    field :state
    field :postalCode
    field :country
    field :countryCode
    field :email
    field :telephone
    field :fax

    def self.selectively_create_from_hash(h)
      attr = {
        :name         => h['name'],
        :organization => h['organization'],
        :street1      => h['street1'],
        :street2      => h['street2'],
        :city         => h['city'],
        :state        => h['state'],
        :postalCode   => h['postalCode'],
        :country      => h['country'],
        :countryCode  => h['countryCode'],
        :email        => h['email'],
        :telephone    => h['telephone'],
        :fax          => h['fax'],
      }
      Contact.create(attr)
    end

  end
end